let persistent_storage = ref ".persistent_hash"

let port = ref 11111
let speclist = ["-port",Arg.Int (fun x -> port := x), "port number to connect to (default 11111)";
		"-hash_database",Arg.String (fun x -> persistent_storage:= x), "location of hash database";
	      ]

let max_queue = 100


let process_request ic oc =
  let command,hashes = Server_io.input_server_command ic in
    
  let hashtable = Int_hash_persistent.make_hash_table !persistent_storage in
  let counts = 
    match command with 
	Server_io.Get -> 
	  List.map (fun x -> Int_hash_persistent.get_incr hashtable x) hashes 
      | Server_io.Get_no_incr -> 
	  List.map (fun x -> Int_hash_persistent.get hashtable x) hashes  
      | Server_io.Illegal -> [] in
    Int_hash_persistent.close hashtable;
    Server_io.output_client_reply oc counts;
    flush oc;
    exit 0
  
let _ = 
  Arg.parse speclist (fun x -> persistent_storage := x) "";
  
  Unix.establish_server process_request (Unix.ADDR_INET (Unix.inet_addr_any,!port));

