let input_file ic len =
  let block = String.create len in
  
  let rec internal_power_read ic block begin_point size = 
    let num_read = input ic block begin_point size in
    if num_read = size or num_read = 0 then num_read
    else num_read + internal_power_read ic block (begin_point+num_read) (size-num_read) in
  
  let size = internal_power_read ic block 0 len in
  String.sub block 0 size

let max_word_size = 100 

let input_word ic = 
  let string = String.create max_word_size in
  let ptr = ref 0 in
  let input = ref (input_char ic) in
  while !input <> ' ' & !ptr < max_word_size do
    string.[!ptr] <- !input;
    incr ptr;
    input := input_char ic;
  done;
  String.sub string 0 !ptr

let output_word ic word =
  output_string ic (word^" ")

let input_list ic foo = 
  let number = int_of_string (input_word ic) in
  let ret = ref [] in
  for i = 0 to number - 1 do
    ret := (foo ic) :: !ret
  done;
  List.rev !ret

let output_list oc foo list = 
  output_word oc (string_of_int (List.length list));
  List.iter (fun x -> foo oc x) list
  
exception Io_failure

let input_unix_word ic = 
  let string = String.create max_word_size in
  let ptr = ref 0 in
  let num = Unix.read ic string 0 1 in
  if num <> 1 then raise Io_failure;
  while string.[!ptr] <> ' ' & !ptr < max_word_size - 1 do
    incr ptr;
    let num = Unix.read ic string !ptr 1 in
    if num <> 1 then raise Io_failure;
  done;
  String.sub string 0 !ptr

let output_unix_word ic word =
  let output = word^" " in
  let len = Unix.write ic output 0 (String.length output) in
  if len <> String.length output then raise Io_failure

let input_unix_list ic foo = 
  let number = int_of_string (input_unix_word ic) in
  let ret = ref [] in
  for i = 0 to number - 1 do
    ret := (foo ic) :: !ret
  done;
  List.rev !ret

let output_unix_list oc foo list = 
  output_unix_word oc (string_of_int (List.length list));
  List.iter (fun x -> foo oc x) list
  
