type command = Get_no_incr | Get | Illegal

let input_server_command ic = 
  let command = match Io.input_word ic with
    "Get" -> Get
  | "Get_no_incr" -> Get_no_incr 
  | _ -> Illegal in
  let hash_len = int_of_string (Io.input_word ic) in
  let hashes = 
    if command <> Illegal then
      Io.input_list ic (fun ic -> 
	let hash = String.create hash_len in
	really_input ic hash 0 hash_len;
	hash) 
    else [] in
  command,hashes
    
let output_server_command oc (command,hashes) = 
  Io.output_word oc
    begin
      match command with
	Get ->  "Get"
      | Get_no_incr -> "Get_no_incr"
      | Illegal -> "Illegal"
    end;
  Io.output_word oc (string_of_int (String.length (List.hd hashes)));
  Io.output_list oc (fun oc x -> output_string oc x ) hashes
    
let input_client_reply ic = 
  Io.input_list ic (fun ic -> int_of_string (Io.input_word ic))
    
let output_client_reply oc counts =
  Io.output_list oc (fun oc x -> Io.output_word oc (string_of_int x)) counts
