let is_white c = c = '\t' or c = ' ' or c = '\n'

let rip file_string =
  let canonical = String.lowercase file_string in
  let header,body = 
    try
      let match_pos = Str.search_forward (Str.regexp "\n\n") canonical 0 in
      let header = String.sub canonical 0 match_pos in
      let body = String.sub canonical match_pos (String.length canonical - match_pos) in
      header,body
    with Not_found -> canonical,"" in
  let subject = 
    try
      let subject_pos = Str.search_forward (Str.regexp "subject: \(.*\)") header 0 in
      Str.matched_group 1 header
    with Not_found -> "" in
  let from = 
    try 
      let from_pos = Str.search_forward (Str.regexp "from: \(.*\)") header 0 in
      Str.matched_group 1 header
    with Not_found -> "" in
  let canonical = from^" "^subject^" "^body in
  let last = ref '\000' in
  let index = ref 0 in
  for i = 0 to String.length canonical - 1 do
    if is_white !last & is_white canonical.[i] then ()
    else 
      begin 
	canonical.[!index] <- canonical.[i];
	last := canonical.[i];
	incr index;
      end
  done;
  let canonical = String.sub canonical 0 !index in
  canonical

